using UnityEngine;

namespace SS
{
  public class Mod
  {
    public static void Main()
    {
      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Brick"),
        NameOverride = "Smart Spawner",
        DescriptionOverride = "Smart item spawner with many customizations",
        NameToOrderByOverride = "!Smart Spawner",
        CategoryOverride = ModAPI.FindCategory("Machinery"),
        ThumbnailOverride = ModAPI.LoadSprite("spawnerView.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("spawnerSprite.png");
          Instance.FixColliders();

          var phys = Instance.GetComponent<PhysicalBehaviour>();
          phys.Properties = ModAPI.FindPhysicalProperties("Flammable metal");
          phys.TrueInitialMass = 20f;
          phys.InitialMass = 20f;
          phys.rigidbody.mass = 20f;
          var spawner = Instance.GetOrAddComponent<SmartSpawnerBehaviour>();
		  
		  var SpawnerGlow = new GameObject("Smart Spawner glow");
		  SpawnerGlow.transform.SetParent(Instance.transform);
		  SpawnerGlow.transform.localPosition = new Vector3(0, 0f);
		  var SpawnerGlowSprite = SpawnerGlow.AddComponent<SpriteRenderer>();
		  SpawnerGlowSprite.sprite = ModAPI.LoadSprite("spawnerGlowSprite.png");;
		  SpawnerGlowSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
		  spawner.SpawnerGlow = SpawnerGlow;

		  var SpawnerLineObj = new GameObject();
		  SpawnerLineObj.transform.SetParent(Instance.transform);
		  SpawnerLineObj.transform.localPosition = new Vector3(0, 0f);
		  spawner.SpawnerLineObj = SpawnerLineObj;

		  var SpawnerLine = SpawnerLineObj.AddComponent<LineRenderer>();
		  SpawnerLine.useWorldSpace = false;
		  SpawnerLine.sortingLayerName = "Background";
		  SpawnerLine.sharedMaterial = ModAPI.FindMaterial("Sprites-Default");
		  SpawnerLine.transform.position = Instance.transform.position;
		  SpawnerLine.startWidth = 0.05f;
		  SpawnerLine.endWidth = 1.0f;
		  SpawnerLine.enabled = true;
		  spawner.SpawnerLine = SpawnerLine;
        }
      });
    }
  }
}
